using namespace std;
#include <iostream>
#include <fstream>
#include "rv_generate.h"
#include "BS.h"
#include "MS.h"
#include "LINK.h"
#include "channel.h"
#include "sector.h"



unsigned long _seed = 100000;
Rand randnum((unsigned long long int)_seed);

int num_drop;
int run_times;
int num_compute_coef;
int test_environment;
int pathloss_model;
int num_neighbor;
double grid_interval;

int TYPE;
int num_BS;
int num_MS;
int num_MS_persector;
int num_Indoor_TRxP;
int num_SECTORS;
int num_LINK;
int BS_M, BS_N, BS_Mg, BS_Ng, BS_Mp, BS_Np, BS_P;  /// tx antenna element
double BS_dH, BS_dV, BS_dgH, BS_dgV;
int MS_M, MS_N, MS_Mg, MS_Ng, MS_Mp, MS_Np, MS_P;  /// rx antenna element
double MS_dH, MS_dV, MS_dgH, MS_dgV;
int NUM_RX;
int NUM_TX;
int NUM_TX_Port;
int NUM_RX_Port;
int Scheduling_Type;
int scenario;
int Configuration_Type; /// For IMT-2020
int Channel_Model_Type; /// For IMT-2020
int CH_CAL;
int Calibration_mode;

complex <double> w[4][8];                              // [num_vertical steering angle][num element in a port] (maximum)
complex <double> v[4][8][8];                           // [num_vertical steering angle][num_horizontal sterring angle][num element in a port]  (maximum)
complex <double> virtualization_weight_wv[4][8][8][8]; // [vertical steering angle ][horizontal steering angle][vertical_element per port][horizontal_element per port]

complex <double> ue_w[4][8];                              // [num_vertical steering angle][num element in a port] (maximum)
complex <double> ue_v[4][8][8];                           // [num_vertical steering angle][num_horizontal sterring angle][num element in a port]  (maximum)
complex <double> ue_virtualization_weight_wv[4][8][8][8]; // [vertical steering angle ][horizontal steering angle][vertical_element per port][horizontal_element per port]

int tilt_azimuth_angle_LCS_size;
int tilt_zenith_angle_LCS_size;

int ue_tilt_azimuth_angle_LCS_size;
int ue_tilt_zenith_angle_LCS_size;

double bs_tilt_azimuth_angle_LCS[8];  //// pi  max8
double bs_tilt_zenith_angle_LCS[4];  /// theta  max4

double ue_tilt_azimuth_angle_LCS[4];  //// pi  max4
double ue_tilt_zenith_angle_LCS[2];  /// theta  max2

complex <double> * TX_LOS_gain_theta;
complex <double> * TX_LOS_gain_pi;
complex <double> *** TX_NLOS_gain_theta;
complex <double> *** TX_NLOS_gain_pi;

complex <double> * RX_LOS_gain_theta;
complex <double> * RX_LOS_gain_pi;
complex <double> *** RX_NLOS_gain_theta;
complex <double> *** RX_NLOS_gain_pi;

char * file_name;

double ** Capacity_avr_per_drop;

double user_speed;
double W;
double h;
double Frequency;
double Total_BS_Tx_power;
double Wavelength;
double bs_maxpower;
double ms_maxpower;
double max_antgain;
double bandwidth;
double noise;
double BS_noisefig;
double MS_noisefig;
double ue_antenna_element_gain;
double bs_height;
double ms_height;
double ms_height_out;
double ms_height_in;

int num_floor;
int num_propagation_condition;

double inter_site_distance;
double min_distance;
double ANGLE_tilt;
double MAX_v_angle;

void Set_Parameter();
void Initialdrop();

// MU MIMO
int               *** pppPMI_map;
VectorXcd         *** pppPMI_vector_map;
double            *** pppCQI_Map;
int num_rbs_in_1ms = 50;
int cqi_history_length = 8;


int       mx_ue_mumimo = 2;
double epsilon = 0.4;   //
int    mcs_decision = 1;
Matrix4cd WW[16];
Vector4cd code_word[64];

// simulation run variables
int t;
int drop_idx;

// simulation configure variables

int SCHEDULE_DELAY = 4;

//int run_times = 2000;
//int SCHEDULE_DELAY = 5;
int precalculate_time = 2000;
int anglev_mapping_value = 3;


complex <double> **** CHIR_precalc[2][2];
MatrixXcd **Hm[2][2];
int ** PMI_precalc[20000][2][2];
double **sinr_estimate_precalc[20000][2][2];
double **sum_of_ch_coef_precalc[20000][2][2];



//standard
double    overhead = 0.31;
bool      calibration = false;

// CQI & Schedule Map
SCHEDULE_DECISION *** pppSchedule_Map;
//double N_pf = 100;
double N_pf = 1;

//int SCHEDULE_TYPE = 1;

//receive downlink
int lls_mapping = 0;

//logging point
char path[50];

BS* bs;
MS* ms;
LINK* link;
CHANNEL** channel;
Sector* sector;






