#include "const.h"



#ifndef _CHANNEL_H_
#define _CHANNEL_H_

class CHANNEL
{
public:

	void Set_channel(double, bool, int, int, LOCATION, LOCATION);
	void Set_SmallScaleParameter(int, int);
	void Allocate_memory();
	void Delete_memory();
	void Delete_CHIR_memory();
	void Update(double, int, int);
	void Update_per_time(double,int, int);
	void Precalculate(int);
	//void Kill_precalculate(void);
	void Load_precalculate(double, int, int);
	double LOS_prob;
	double pathloss;
	double pathloss_2;
	double pathloss_final;
	LOCATION self_bs;
	LOCATION self_ms;
	bool LOS;
	int Propagation;
	bool Indoor;
	double RMS_delay_spread;
	double circular_angle_spread_AOA;
	double circular_angle_spread_AOD;

	int self_bs_idx;
	int self_ms_idx;
	LOCATION bs_location;
	LOCATION ms_location;

	double* delay;
	double* delay_LOS;

	double* power;
	double* power_LOS;
	double* power_NLOS;

	double LOS_AOA_GCS;
	double LOS_AOD_GCS;
	double LOS_ZOA_GCS;
	double LOS_ZOD_GCS;

	double* AOA;
	double* AOD;
	double* ZOA;
	double* ZOD;

	double* AOA_LOS;
	double* AOD_LOS;
	double* ZOA_LOS;
	double* ZOD_LOS;

	double* AOA_NLOS;
	double* AOD_NLOS;
	double* ZOA_NLOS;
	double* ZOD_NLOS;
	
	double* delay_power;
	double* RMS_delay_power;
	double* power_ray_sum;
	double* power_ray_sum_circular;
	double* AOA_power;
	double* AOD_power;
	double* theta_n_m_mu_AOA;
	double* theta_n_m_mu_AOD;
	double* theta_power_AOA;
	double* theta_power_AOD;

	double strongest_power;
	double strongest_power2;
	int strongest_power_idx;
	int strongest_power_idx2;

	double** random_phase_vv;
	double** random_phase_vh;
	double** random_phase_hv;
	double** random_phase_hh;
	double random_phase_vv_LOS;
	double random_phase_hh_LOS;

	complex <double> F_tx_v;
	complex <double> F_tx_h;
	complex <double> F_rx_v;
	complex <double> F_rx_h;

	complex <double> F_vv;
	complex <double> F_vh;
	complex <double> F_hv;
	complex <double> F_hh;

	double d_rx;
	double d_tx;

	//int	bs_idx;
	int ms_idx;

	complex <double> **** CHIR;
	complex <double> *** CHIR_LOS;

	//MatrixXcd *** CHIR_Matrix;
	//complex <double> ******* CHIR_precalculate;

	double ** offset_angle;
	double ** offset_angle_rand_coupling;
	double * NUM_RAY_per_ClusterNUM;

	//parameter
	int num_ray;
	int num_path;
	int NUM_PATH_for_channelcoeff; 
	double distance;


	double D;
	double r_tau;
	double K_factor;
	//double sigma_tau;
	double DS; /// = sigma_tau in M.2135
	double mu_K_factor;
	double sigma_K_factor;
	double mu_DS;
	double sigma_DS;
	double mu_ASD;
	double sigma_ASD;
	double mu_ASA;
	double sigma_ASA;
	double mu_ZSA;
	double sigma_ZSA;
	double mu_ZSD;
	double sigma_ZSD;

	double _DS;
	double K_dB;
	double K_linear;
	double ASA;
	double ASD;
	double ZSA;
	double ZSD;
	//double K_R;
	double P_1LOS;
	double mu_XPR;
	double sigma_XPR;

	double XPR_mean[3];
	double XPR_std[3];
	double kappa[24][20];

	double mu_offset_ZOD;

	double cluster_DS;
	double cluster_ASD;
	double cluster_ASA;
	double cluster_ZSA;
	double XPR;
	double cluster_shadowing;
	double sigma_SF;
	//double d_rx;
	//double d_tx;
	//int BS_M, BS_N, BS_Mg, BS_Ng;  /// tx antenna element
	//int MS_M, MS_N, MS_Mg, MS_Ng;  /// rx antenna element
	double BS_d_H, BS_d_V, BS_d_gH, BS_d_gV;
	double MS_d_H, MS_d_V, MS_d_gH, MS_d_gV;
	double alpha, beta, gamma;
	MatrixXd W_tx;
	MatrixXd W_rx;
	
	double correlated_randnum_SF;
	double correlated_randnum_DS;
	double correlated_randnum_ASD;
	double correlated_randnum_ASA;
	double correlated_randnum_K;

	void Set_LOS_Prob();
	void Set_PATHLOSS();
	//void Set_SHADOWFADING();
	void Set_Channel_Parameters();

	void Set_DELAY();
	void Set_POWER();
	void Find_Strong2Clusters();
	void Set_AOAAOD(int, int);
	void Set_ZOAZOD(int, int);
	void Set_InitialPhase();
	void Set_SUBCLUSTER();
	void Set_W_matrix();
	void Set_RMS_delay_spread();
	void Set_circular_angle_spread();

	void Set_AOAAOD_LOS();
	void Set_AOAAOD_NLOS();

	void Set_ZOAZOD_LOS();
	void Set_ZOAZOD_NLOS();

	void Kill_Memory();

	double signal_RSRP_gain[3][4][8][2][4][2]; //[sec_idx] [sec_zenith][sec_azimuth][ue_zenith_idx][ue_azimuth_idx][pannel];  

	double final_ant_gain;

	//double signal_RSRP_gain_PORT[3][32][4]; //[sec_idx] [max TX port] [max RX port];  


	/*
	double tx_LOS_antenna_field_theta[3][4][8]; // SECTOR,  [sec_idx] [sec_zenith][sec_azimuth][max_TX_port]
	double tx_LOS_antenna_field_pi[3][4][8];

	double tx_NLOS_antenna_field_theta[3][4][8][24][20]; // [sec_idx] [sec_zenith][sec_azimuth][max_TX_port][max num clusters][max_num_rays]
	double tx_NLOS_antenna_field_pi[3][4][8][24][20];

	double rx_LOS_antenna_field_theta[2][4][2]; // UE,  [ue_zenith_idx][ue_azimuth_idx][UE_panel][max_RX_port]
	double rx_LOS_antenna_field_pi[2][4][2];

	double rx_NLOS_antenna_field_theta[2][4][2][24][20]; // UE,  [ue_zenith_idx][ue_azimuth_idx][UE_panel][max_RX_port][max cluster][max ray]
	double rx_NLOS_antenna_field_pi[2][4][2][24][20];
	*/

private:
	



};

#endif