#include <iostream>
#include <fstream>

using namespace std;

#include <cstring>
#include <cstdlib>

#include "common.h"
#include "const.h"

double FER(double SINR, int MCS);



void Measure()
{
	if (Scheduling_Type == 0)
	{
		for (int idx = 0; idx < num_MS; idx++)
		{
			ms[idx].Receive_DL(idx);
		}
		cout << " Receive_DL... done" << endl;
	}
	else
	{

		for (int idx = 0; idx < num_MS; idx++)
		{
			ms[idx].Receive_DL(idx);
		}
		cout << " Receive_DL... done" << endl;


		// K SIM method
		/*
		for (int sector_idx = 0; sector_idx < num_SECTORS; sector_idx++)
		{
			int idx = sector[sector_idx].ue_scheduled_mumimo(0);

			ms[idx].instantThroughput = 0;

			ms[idx].Received_SINR();

			double temp = ms[idx].downlinkESINR;

			if (randnum.u() > FER(temp, ms[idx].ue_MCS))
			{
				ms[idx].instantThroughput = ms[idx].downlinkspectralefficiency * num_rbs_in_1ms * (12 * 11 - 12 - 16) * 1000;
				ms[idx].downlinkHARQeSINR = 0;
			}
			else
			{
				ms[idx].instantThroughput = 0;
				ms[idx].downlinkHARQeSINR = ms[idx].downlinkHARQeSINR + temp;
			}

			ms[idx].downlinkThroghput = ms[idx].downlinkThroghput * (t) / (t + 1) + ms[idx].instantThroughput / (t + 1);
		}
		for (int sector_idx = 0; sector_idx < num_SECTORS; sector_idx++)
		{

			int idx = sector[sector_idx].ue_scheduled_mumimo(0);

			ms[idx].downlinkaveragedThroghput = ms[idx].downlinkaveragedThroghput*(t) / (t + 1) + ms[idx].downlinkThroghput / (t + 1);

			link[idx]._throughput = ms[idx].downlinkThroghput;

		}
		cout << " Receive_DL... done" << endl;
		*/





	}
}



double FER(double SINR, int MCS)
{
	double Frame_Error_Rate = 1;
	double ESINR_L = SINR; // linear value
	switch (MCS)
	{
	case -1:
		Frame_Error_Rate = 0.0;
		break;

	case 0:
		if (ESINR_L < pow(10.0, -7.737 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(69.109 - 410.4 * ESINR_L);
		break;
	case 1:
		if (ESINR_L < pow(10.0, -5.852 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(70.072 - 269.63 * ESINR_L);

		break;

	case 2:
		if (ESINR_L < pow(10.0, -3.737 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(69.19 - 163.42 * ESINR_L);

		break;

	case 3:
		if (ESINR_L < pow(10.0, -1.718 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(70.491 - 104.69 * ESINR_L);

		break;

	case 4:
		if (ESINR_L < pow(10.0, 0.3206 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(77.142 - 71.651* ESINR_L);

		break;

	case 5:
		if (ESINR_L < pow(10.0, 2.14 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(47.496 - 29.018 * ESINR_L);

		break;

	case 6:
		if (ESINR_L < pow(10.0, 4.096 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(45.163 - 17.585 * ESINR_L);

		break;

	case 7:
		if (ESINR_L < pow(10.0, 6.052 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(45.936 - 11.402 * ESINR_L);

		break;

	case 8:
		if (ESINR_L < pow(10.0, 8.03 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(44.625 - 7.0239 * ESINR_L);

		break;

	case 9:
		if (ESINR_L < pow(10.0, 10.03 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(46.766 - 4.6398 * ESINR_L);

		break;

	case 10:
		if (ESINR_L < pow(10.0, 11.82 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(41.834 - 2.7525 * ESINR_L);

		break;
	case 11:
		if (ESINR_L < pow(10.0, 13.65 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(33.542 - 1.4485 * ESINR_L);

		break;
	case 12:
		if (ESINR_L < pow(10.0, 15.69 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(29.392 - 0.79247 * ESINR_L);

		break;
	case 13:
		if (ESINR_L < pow(10.0, 17.5 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(29.525 - 0.52504 * ESINR_L);

		break;
	case 14:
		if (ESINR_L < pow(10.0, 18.98 / 10.0))
			Frame_Error_Rate = 1.0;
		else
			Frame_Error_Rate = exp(8.154 - 0.10315 * ESINR_L);

		break;
	}
	return Frame_Error_Rate;
}